## adequate 0.17.5

=== debian/changelog ===
adequate (0.17.5) unstable; urgency=medium

  * Commit the output of go-md2man so that we can drop it from Build-Depends.
    What feeds into it typically requires several manual steps anyway (see
    "Adding a new tag" in CONTRIB.md), so there's little value in running it
    on every build.

 -- Serafeim Zanikolas <sez@debian.org>  Sat, 04 Jan 2025 21:15:48 +0100

adequate (0.17.4) unstable; urgency=medium

  * Various implementation changes to make adequate build with gccgo-12.
    Relax version constraint on golang-any build-dependency to go 1.18.

 -- Serafeim Zanikolas <sez@debian.org>  Sat, 04 Jan 2025 20:34:47 +0100

=== debian/control ===
Source: adequate
Section: utils
Priority: optional
Maintainer: Debian Adequate Maintainers <team+adequate-maint@tracker.debian.org>
Uploaders: Serafeim Zanikolas <sez@debian.org>
Build-Depends: debhelper (>= 13.4),
               debhelper-compat (= 13),
               golang-any (>= 2:1.18),
	       golang-github-google-go-cmp-dev,
	       dh-golang,
               python3,
               python3-apt
Standards-Version: 4.7.0
Vcs-Git: https://salsa.debian.org/debian/adequate.git
Vcs-Browser: https://salsa.debian.org/debian/adequate
Homepage: https://salsa.debian.org/debian/adequate
Rules-Requires-Root: no
XS-Go-Import-Path: salsa.debian.org/debian/adequate
Testsuite: autopkgtest-pkg-go, autopkgtest-pkg-adequate

Package: adequate
Architecture: any
Depends: debconf,
	 ${shlibs:Depends},
         ${misc:Depends},
Built-Using: ${misc:Built-Using}
Recommends: pkgconf
Description: Debian package quality testing tool
 adequate checks packages installed on the system and reports bugs and policy
 violations.
 .
 The following checks are currently implemented:
  * broken symlinks;
  * missing copyright file;
  * obsolete conffiles;
  * Python modules not byte-compiled;
  * missing libraries, undefined symbols, symbol size mismatches;
  * program name collisions;
  * missing alternatives;
  * missing binfmt interpreters and detectors;
  * missing pkg-config dependencies;
  * invalid user/group values in systemd/D-Bus/sysvinit files.

=== tests/testpkg/debian/rules ===
#!/usr/bin/make -f

tmp = debian/tmp
at = adequate-test

debian/control: debian/control.in
	sed -r 's/#$(shell test "$$(readlink -f /bin)" = "$$(readlink -f /usr/bin)" || echo "non-")merged-usr#//' $< > $@

%: debian/control
	dh $@

override_dh_auto_install:
	mkdir -p $(tmp)
	# library-not-found
	$(CC) lib.c -fPIC -shared -Wl,-soname,libadequate-lib.so.0 -o $(tmp)/libadequate-lib.so.0
	ln -sf libadequate-lib.so.0 $(tmp)/libadequate-lib.so
	$(CC) lib.c -fPIC -shared -Wl,-soname,libadequate-usrlib.so.0 -o $(tmp)/libadequate-usrlib.so.0
	ln -sf libadequate-usrlib.so.0 $(tmp)/libadequate-usrlib.so
	$(CC) prog.c -L$(tmp) -Wl,--no-as-needed -ladequate-lib -o $(tmp)/adequate-lib1
	cd $(tmp) && seq 2 5 | xargs -t -I {} ln -f adequate-lib1 adequate-lib{}
	$(CC) prog.c -L$(tmp) -Wl,--no-as-needed -ladequate-usrlib -o $(tmp)/adequate-usrlib1
	cd $(tmp) && seq 2 5 | xargs -t -I {} ln -f adequate-usrlib1 adequate-usrlib{}
	# missing-version-information
	$(CC) -shared -Wl,--soname=lib$(at)-versionless.so.0 -Wl,--version-script=verscript-global lib.c -o $(tmp)/lib$(at)-versionless.so.0
	ln -sf lib$(at)-versionless.so.0 $(tmp)/lib$(at)-versionless.so
	$(CC) undef.c -L$(tmp) -o $(tmp)/$(at)-msvi -l$(at)-versionless
	$(CC) -shared -Wl,--no-as-needed -Wl,--soname=lib$(at)-versionless.so.0 lib.c -o $(tmp)/lib$(at)-versionless.so.0
	# symbol-size-mismatch
	$(CC) -shared -Wl,--soname=lib$(at)-symsize.so.0 lib.c -o $(tmp)/lib$(at)-symsize.so.0
	ln -sf lib$(at)-symsize.so.0 $(tmp)/lib$(at)-symsize.so
	$(CC) symsize.c -L$(tmp) -o $(tmp)/$(at)-symsize -l$(at)-symsize
	$(CC) -shared -Wl,--soname=lib$(at)-symsize.so.0 -DADEQUATE_SYMBOL_SIZE=42 lib.c -o $(tmp)/lib$(at)-symsize.so.0
	readelf --wide --symbols $(tmp)/$(at)-symsize | grep this_symbol_size_varies
	test "$$(readelf --wide --symbols $(tmp)/$(at)-symsize | grep this_symbol_size_varies | head -n 1 | awk '{print $$3}')" != "0" || touch $(tmp)/skip-symbol-size-mismatch
	# undefined-symbol
	$(CC) -shared -Wl,--soname=lib$(at)-versioning.so.0 lib.c -o $(tmp)/lib$(at)-versioning.so.0
	ln -sf lib$(at)-versioning.so.0 $(tmp)/lib$(at)-versioning.so
	$(CC) undef.c -L$(tmp) -o $(tmp)/$(at)-us1 -l$(at)-versioning
	nm $(tmp)/$(at)-us1 | grep 'U this_symbol_might_be_undefined'
	$(CC) -shared -Wl,--soname=lib$(at)-versioning.so.0 -Wl,--version-script=verscript-global lib.c -o $(tmp)/lib$(at)-versioning.so.0
	$(CC) undef.c -L$(tmp) -o $(tmp)/$(at)-us2 -l$(at)-versioning
	nm $(tmp)/$(at)-us2 | grep 'U this_symbol_might_be_undefined@ADEQUATE_TEST'
	$(CC) -shared -Wl,--soname=lib$(at)-versioning.so.0 -Wl,--version-script=verscript-local lib.c -o $(tmp)/lib$(at)-versioning.so.0
	# py-file-not-bytecompiled; pyshared-file-not-bytecompiled
	cp *.py debian/tmp/
	python3 -m compileall debian/tmp/

override_dh_installdocs:
	dh_installdocs -N adequate-testpkg-missing-copyright-file

override_dh_missing:
	dh_missing --list-missing

override_dh_strip:
	dh_strip --no-automatic-dbgsym

# we build binaries with missing symbols
override_dh_shlibdeps:

override_dh_gencontrol:
	dh_gencontrol $(patsubst $(tmp)/skip-%,-N adequate-testpkg-%,$(wildcard $(tmp)/skip-*))

override_dh_builddeb:
	dh_builddeb $(patsubst $(tmp)/skip-%,-N adequate-testpkg-%,$(wildcard $(tmp)/skip-*))

execute_after_dh_builddeb:
	rm debian/adequate-testpkg-obsolete-conffile/etc/adequate/test-obsolete-conffile
	sed -i -e '/test-obsolete/d' debian/adequate-testpkg-obsolete-conffile/DEBIAN/conffiles
	dh_gencontrol -p adequate-testpkg-obsolete-conffile -- -v2 -fdebian/files2
	cat debian/files2 >> debian/files
	rm -f debian/files2
	dh_md5sums -p adequate-testpkg-obsolete-conffile
	dh_builddeb -p adequate-testpkg-obsolete-conffile

## adequate 0.17.6

=== doc/Makefile ===
.PHONY: all
all: adequate.1

adequate.md: manpage.header manpage.footer tags.desc
	cd ../private && go run gen-markdown-manpage.go

# This should depend on adequate.md, but it doesn't to keep things simple.
# (That target depends on the adequate binary to get the list of tags, and
# that's not necessarily built before the manpage.)
adequate.1:
	go-md2man -in=adequate.md -out=adequate.1

manpage-preview:
	man -l adequate.1

.PHONY: clean
clean:

# vim:ts=4 sts=4 sw=4 noet

=== tests/Makefile ===
arch = $(shell dpkg-architecture -qDEB_HOST_ARCH)
changes = adequate-testpkg_1_$(arch).changes

.PHONY: all
all: $(changes)
	$(info Run "make run" as root.)
	$(info Alternatively, if you have user-mode-linux installed, you can try "make run-uml" as normal user.)
	$(info )@:

.PHONY: changes
changes: $(changes)

$(changes):
	cd testpkg && debian/rules debian/control
	cd testpkg && dpkg-buildpackage -b -us -uc

.PHONY: run
run: $(changes)
	./run-tests $(<)

.PHONY: run-uml
run-uml: $(changes)
	fallocate -l 1G uml-guest-swap
	linux init=$(CURDIR)/uml-guest-init \
		$(shell printf '%s' '$(CURDIR)' | base64 -w0 | tr = _) \
		$(shell printf '%s' '$(<)' | base64 -w0 | tr = _) \
		rootfstype=hostfs ubd0=uml-guest-swap mem=128M quiet con=null,fd:1 \
	| cat

.PHONY: clean
clean:
	cd testpkg && debian/rules clean
	$(RM) testpkg/debian/control
	rm -f *.changes *.buildinfo *.deb
	rm -f uml-guest-swap

# vim:ts=4 sts=4 sw=4 noet

=== debian/changelog ===
adequate (0.17.6) unstable; urgency=medium

  * Fix missing-pkgconfig-dependency checks for packages that ship .pc files
    in directories that are not in pkgconf's default search path. Closes:
    #1109018.
  * d/control:
    * Bump standards version (no changes needed).
    * Add Static-Built-Using; drop Built-Using.

 -- Serafeim Zanikolas <sez@debian.org>  Fri, 22 Aug 2025 22:31:31 +0200

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
 	       dh-golang,
                python3,
                python3-apt
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Vcs-Git: https://salsa.debian.org/debian/adequate.git
 Vcs-Browser: https://salsa.debian.org/debian/adequate
 Homepage: https://salsa.debian.org/debian/adequate
@@ -23,7 +23,7 @@
 Depends: debconf,
 	 ${shlibs:Depends},
          ${misc:Depends},
-Built-Using: ${misc:Built-Using}
+Static-Built-Using: ${misc:Static-Built-Using}
 Recommends: pkgconf
 Description: Debian package quality testing tool
  adequate checks packages installed on the system and reports bugs and policy

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

export DH_VERBOSE=1

%:
	dh $@ --builddirectory=_build --with=golang

override_dh_auto_clean:
	$(MAKE) -C tests/ clean
	rm -rf _build adequate

override_dh_auto_test:
ifeq "$(filter nocheck,$(DEB_BUILD_OPTIONS))" ""
	adt_adequate=_build/bin/adequate adt_testpkg=dpkg debian/tests/smoke-test
	$(MAKE) -C tests/ changes
endif

execute_before_dh_auto_build:
	sed -i -e 's/dummy-adequate-version/$(DEB_VERSION)/' \
		_build/src/salsa.debian.org/debian/adequate/adequate.go
execute_after_dh_auto_build:
	rm -rf _build/src _build/bin/private

=== debian/tests/control ===
Tests: smoke-test
Depends: adequate
Restrictions: superficial

Tests: adequate-on-adequate
Depends: adequate, pkgconf
Restrictions: superficial

Tests: full-test
Depends: adequate,
         build-essential,
         debhelper-compat (= 13),
         pkg-config (>= 0.27),
         python3,
         python3-apt
Restrictions: breaks-testbed needs-root
